# Class BoxView

java.lang.Object
javax.swing.text.View
javax.swing.text.CompositeView
javax.swing.text.BoxView

All Implemented Interfaces:
  `SwingConstants`

Direct Known Subclasses:
  `BlockView, FlowView, TableView, TableView.TableCell, TableView.TableRow, WrappedPlainView, ZoneView`

public class BoxView extends CompositeView
A view that arranges its children into a box shape by tiling its children along an axis. The box is somewhat like that found in TeX where there is alignment of the children, flexibility of the children is considered, etc. This is a building block that might be useful to represent things like a collection of lines, paragraphs, lists, columns, pages, etc. The axis along which the children are tiled is considered the major axis. The orthogonal axis is the minor axis.

Layout for each axis is handled separately by the methods `layoutMajorAxis` and `layoutMinorAxis`. Subclasses can change the layout algorithm by reimplementing these methods. These methods will be called as necessary depending upon whether or not there is cached layout information and the cache is considered valid. These methods are typically called if the given size along the axis changes, or if `layoutChanged` is called to force an updated layout. The `layoutChanged` method invalidates cached layout information, if there is any. The requirements published to the parent view are calculated by the methods `calculateMajorAxisRequirements` and `calculateMinorAxisRequirements`. If the layout algorithm is changed, these methods will likely need to be reimplemented.

- ## Field Summary

  ### Fields declared in class View

  `BadBreakWeight, ExcellentBreakWeight, ForcedBreakWeight, GoodBreakWeight, X_AXIS, Y_AXIS`
  Modifier and Type
  Field
  Description
  `static final int`
  `BadBreakWeight`
  The weight to indicate a view is a bad break opportunity for the purpose of formatting.
  `static final int`
  `ExcellentBreakWeight`
  The weight to indicate a view supports breaking, and this represents a very attractive place to break.
  `static final int`
  `ForcedBreakWeight`
  The weight to indicate a view supports breaking, and must be broken to be represented properly when placed in a view that formats its children by breaking them.
  `static final int`
  `GoodBreakWeight`
  The weight to indicate a view supports breaking, but better opportunities probably exist.
  `static final int`
  `X_AXIS`
  Axis for format/break operations.
  `static final int`
  `Y_AXIS`
  Axis for format/break operations.

  ### Fields declared in interface SwingConstants

  `BOTTOM, CENTER, EAST, HORIZONTAL, LEADING, LEFT, NEXT, NORTH, NORTH_EAST, NORTH_WEST, PREVIOUS, RIGHT, SOUTH, SOUTH_EAST, SOUTH_WEST, TOP, TRAILING, VERTICAL, WEST`
  Modifier and Type
  Field
  Description
  `static final int`
  `BOTTOM`
  Box-orientation constant used to specify the bottom of a box.
  `static final int`
  `CENTER`
  The central position in an area.
  `static final int`
  `EAST`
  Compass-direction east (right).
  `static final int`
  `HORIZONTAL`
  Horizontal orientation.
  `static final int`
  `LEADING`
  Identifies the leading edge of text for use with left-to-right and right-to-left languages.
  `static final int`
  `LEFT`
  Box-orientation constant used to specify the left side of a box.
  `static final int`
  `NEXT`
  Identifies the next direction in a sequence.
  `static final int`
  `NORTH`
  Compass-direction North (up).
  `static final int`
  `NORTH_EAST`
  Compass-direction north-east (upper right).
  `static final int`
  `NORTH_WEST`
  Compass-direction north west (upper left).
  `static final int`
  `PREVIOUS`
  Identifies the previous direction in a sequence.
  `static final int`
  `RIGHT`
  Box-orientation constant used to specify the right side of a box.
  `static final int`
  `SOUTH`
  Compass-direction south (down).
  `static final int`
  `SOUTH_EAST`
  Compass-direction south-east (lower right).
  `static final int`
  `SOUTH_WEST`
  Compass-direction south-west (lower left).
  `static final int`
  `TOP`
  Box-orientation constant used to specify the top of a box.
  `static final int`
  `TRAILING`
  Identifies the trailing edge of text for use with left-to-right and right-to-left languages.
  `static final int`
  `VERTICAL`
  Vertical orientation.
  `static final int`
  `WEST`
  Compass-direction west (left).

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BoxView(Element elem, int axis)`
  Constructs a `BoxView`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected void`
  `baselineLayout(int targetSpan, int axis, int[] offsets, int[] spans)`
  Computes the location and extent of each child view in this `BoxView` given the `targetSpan`, which is the width (or height) of the region we have to work with.
  `protected SizeRequirements`
  `baselineRequirements(int axis, SizeRequirements r)`
  Calculates the size requirements for this `BoxView` by examining the size of each child view.
  `protected SizeRequirements`
  `calculateMajorAxisRequirements(int axis, SizeRequirements r)`
  Calculates the size requirements for the major axis `axis`.
  `protected SizeRequirements`
  `calculateMinorAxisRequirements(int axis, SizeRequirements r)`
  Calculates the size requirements for the minor axis `axis`.
  `protected void`
  `childAllocation(int index, Rectangle alloc)`
  Allocates a region for a child view.
  `protected boolean`
  `flipEastAndWestAtEnds(int position, Position.Bias bias)`
  Determines in which direction the next view lays.
  `protected void`
  `forwardUpdate(DocumentEvent.ElementChange ec, DocumentEvent e, Shape a, ViewFactory f)`
  Forwards the given `DocumentEvent` to the child views that need to be notified of the change to the model.
  `float`
  `getAlignment(int axis)`
  Determines the desired alignment for this view along an axis.
  `int`
  `getAxis()`
  Fetches the tile axis property.
  `Shape`
  `getChildAllocation(int index, Shape a)`
  Fetches the allocation for the given child view.
  `int`
  `getHeight()`
  Returns the current height of the box.
  `float`
  `getMaximumSpan(int axis)`
  Determines the maximum span for this view along an axis.
  `float`
  `getMinimumSpan(int axis)`
  Determines the minimum span for this view along an axis.
  `protected int`
  `getOffset(int axis, int childIndex)`
  Fetches the offset of a particular child's current layout.
  `float`
  `getPreferredSpan(int axis)`
  Determines the preferred span for this view along an axis.
  `int`
  `getResizeWeight(int axis)`
  Gets the resize weight.
  `protected int`
  `getSpan(int axis, int childIndex)`
  Fetches the span of a particular child's current layout.
  `protected View`
  `getViewAtPoint(int x, int y, Rectangle alloc)`
  Fetches the child view at the given coordinates.
  `int`
  `getWidth()`
  Returns the current width of the box.
  `protected boolean`
  `isAfter(int x, int y, Rectangle innerAlloc)`
  Determines if a point falls after an allocated region.
  `protected boolean`
  `isAllocationValid()`
  Are the allocations for the children still valid?
  `protected boolean`
  `isBefore(int x, int y, Rectangle innerAlloc)`
  Determines if a point falls before an allocated region.
  `protected boolean`
  `isLayoutValid(int axis)`
  Determines if the layout is valid along the given axis.
  `protected void`
  `layout(int width, int height)`
  Perform layout on the box
  `void`
  `layoutChanged(int axis)`
  Invalidates the layout along an axis.
  `protected void`
  `layoutMajorAxis(int targetSpan, int axis, int[] offsets, int[] spans)`
  Performs layout for the major axis of the box (i.e. the axis that it represents).
  `protected void`
  `layoutMinorAxis(int targetSpan, int axis, int[] offsets, int[] spans)`
  Performs layout for the minor axis of the box (i.e. the axis orthogonal to the axis that it represents).
  `Shape`
  `modelToView(int pos, Shape a, Position.Bias b)`
  Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
  `void`
  `paint(Graphics g, Shape allocation)`
  Renders the `BoxView` using the given rendering surface and area on that surface.
  `protected void`
  `paintChild(Graphics g, Rectangle alloc, int index)`
  Paints a child.
  `void`
  `preferenceChanged(View child, boolean width, boolean height)`
  This is called by a child to indicate its preferred span has changed.
  `void`
  `replace(int index, int length, View[] elems)`
  Invalidates the layout and resizes the cache of requests/allocations.
  `void`
  `setAxis(int axis)`
  Sets the tile axis property.
  `void`
  `setSize(float width, float height)`
  Sets the size of the view.
  `int`
  `viewToModel(float x, float y, Shape a, Position.Bias[] bias)`
  Provides a mapping from the view coordinate space to the logical coordinate space of the model.

  ### Methods declared in class CompositeView

  `getBottomInset, getInsideAllocation, getLeftInset, getNextEastWestVisualPositionFrom, getNextNorthSouthVisualPositionFrom, getNextVisualPositionFrom, getRightInset, getTopInset, getView, getViewAtPosition, getViewCount, getViewIndex, getViewIndexAtPosition, loadChildren, modelToView, setInsets, setParagraphInsets, setParent`
  Modifier and Type
  Method
  Description
  `protected short`
  `getBottomInset()`
  Gets the bottom inset.
  `protected Rectangle`
  `getInsideAllocation(Shape a)`
  Translates the immutable allocation given to the view to a mutable allocation that represents the interior allocation (i.e. the bounds of the given allocation with the top, left, bottom, and right insets removed.
  `protected short`
  `getLeftInset()`
  Gets the left inset.
  `protected int`
  `getNextEastWestVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)`
  Returns the next visual position for the cursor, in either the east or west direction.
  `protected int`
  `getNextNorthSouthVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)`
  Returns the next visual position for the cursor, in either the north or south direction.
  `int`
  `getNextVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)`
  Provides a way to determine the next visually represented model location that one might place a caret.
  `protected short`
  `getRightInset()`
  Gets the right inset.
  `protected short`
  `getTopInset()`
  Gets the top inset.
  `View`
  `getView(int n)`
  Returns the n-th view in this container.
  `protected View`
  `getViewAtPosition(int pos, Rectangle a)`
  Fetches the child view that represents the given position in the model.
  `int`
  `getViewCount()`
  Returns the number of child views of this view.
  `int`
  `getViewIndex(int pos, Position.Bias b)`
  Returns the child view index representing the given position in the model.
  `protected int`
  `getViewIndexAtPosition(int pos)`
  Fetches the child view index representing the given position in the model.
  `protected void`
  `loadChildren(ViewFactory f)`
  Loads all of the children to initialize the view.
  `Shape`
  `modelToView(int p0, Position.Bias b0, int p1, Position.Bias b1, Shape a)`
  Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
  `protected void`
  `setInsets(short top, short left, short bottom, short right)`
  Sets the insets for the view.
  `protected void`
  `setParagraphInsets(AttributeSet attr)`
  Sets the insets from the paragraph attributes specified in the given attributes.
  `void`
  `setParent(View parent)`
  Sets the parent of the view.

  ### Methods declared in class View

  `append, breakView, changedUpdate, createFragment, forwardUpdateToView, getAttributes, getBreakWeight, getContainer, getDocument, getElement, getEndOffset, getGraphics, getParent, getStartOffset, getToolTipText, getViewFactory, getViewIndex, insert, insertUpdate, isVisible, modelToView, remove, removeAll, removeUpdate, updateChildren, updateLayout, viewToModel`
  Modifier and Type
  Method
  Description
  `void`
  `append(View v)`
  Appends a single child view.
  `View`
  `breakView(int axis, int offset, float pos, float len)`
  Tries to break this view on the given axis.
  `void`
  `changedUpdate(DocumentEvent e, Shape a, ViewFactory f)`
  Gives notification from the document that attributes were changed in a location that this view is responsible for.
  `View`
  `createFragment(int p0, int p1)`
  Creates a view that represents a portion of the element.
  `protected void`
  `forwardUpdateToView(View v, DocumentEvent e, Shape a, ViewFactory f)`
  Forwards the `DocumentEvent` to the give child view.
  `AttributeSet`
  `getAttributes()`
  Fetches the attributes to use when rendering.
  `int`
  `getBreakWeight(int axis, float pos, float len)`
  Determines how attractive a break opportunity in this view is.
  `Container`
  `getContainer()`
  Fetches the container hosting the view.
  `Document`
  `getDocument()`
  Fetches the model associated with the view.
  `Element`
  `getElement()`
  Fetches the structural portion of the subject that this view is mapped to.
  `int`
  `getEndOffset()`
  Fetches the portion of the model for which this view is responsible.
  `Graphics`
  `getGraphics()`
  Fetch a `Graphics` for rendering.
  `View`
  `getParent()`
  Returns the parent of the view.
  `int`
  `getStartOffset()`
  Fetches the portion of the model for which this view is responsible.
  `String`
  `getToolTipText(float x, float y, Shape allocation)`
  Returns the tooltip text at the specified location.
  `ViewFactory`
  `getViewFactory()`
  Fetches the `ViewFactory` implementation that is feeding the view hierarchy.
  `int`
  `getViewIndex(float x, float y, Shape allocation)`
  Returns the child view index representing the given position in the view.
  `void`
  `insert(int offs, View v)`
  Inserts a single child view.
  `void`
  `insertUpdate(DocumentEvent e, Shape a, ViewFactory f)`
  Gives notification that something was inserted into the document in a location that this view is responsible for.
  `boolean`
  `isVisible()`
  Returns a boolean that indicates whether the view is visible or not.
  `Shape`
  `modelToView(int pos, Shape a)`
  Deprecated.
  `void`
  `remove(int i)`
  Removes one of the children at the given position.
  `void`
  `removeAll()`
  Removes all of the children.
  `void`
  `removeUpdate(DocumentEvent e, Shape a, ViewFactory f)`
  Gives notification that something was removed from the document in a location that this view is responsible for.
  `protected boolean`
  `updateChildren(DocumentEvent.ElementChange ec, DocumentEvent e, ViewFactory f)`
  Updates the child views in response to receiving notification that the model changed, and there is change record for the element this view is responsible for.
  `protected void`
  `updateLayout(DocumentEvent.ElementChange ec, DocumentEvent e, Shape a)`
  Updates the layout in response to receiving notification of change from the model.
  `int`
  `viewToModel(float x, float y, Shape a)`
  Deprecated.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### BoxView

    public BoxView(Element elem, int axis)
    Constructs a `BoxView`.
    Parameters:
      `elem` - the element this view is responsible for
      `axis` - either `View.X_AXIS` or `View.Y_AXIS`

- ## Method Details

  - ### getAxis

    public int getAxis()
    Fetches the tile axis property. This is the axis along which the child views are tiled.
    Returns:
      the major axis of the box, either `View.X_AXIS` or `View.Y_AXIS`
    Since:
      1.3

  - ### setAxis

    public void setAxis(int axis)
    Sets the tile axis property. This is the axis along which the child views are tiled.
    Parameters:
      `axis` - either `View.X_AXIS` or `View.Y_AXIS`
    Since:
      1.3

  - ### layoutChanged

    public void layoutChanged(int axis)
    Invalidates the layout along an axis. This happens automatically if the preferences have changed for any of the child views. In some cases the layout may need to be recalculated when the preferences have not changed. The layout can be marked as invalid by calling this method. The layout will be updated the next time the `setSize` method is called on this view (typically in paint).
    Parameters:
      `axis` - either `View.X_AXIS` or `View.Y_AXIS`
    Since:
      1.3

  - ### isLayoutValid

    protected boolean isLayoutValid(int axis)
    Determines if the layout is valid along the given axis.
    Parameters:
      `axis` - either `View.X_AXIS` or `View.Y_AXIS`
    Returns:
      `true` if the layout is valid along the given axis, otherwise `false`
    Since:
      1.4

  - ### paintChild

    protected void paintChild(Graphics g, Rectangle alloc, int index)
    Paints a child. By default that is all it does, but a subclass can use this to paint things relative to the child.
    Parameters:
      `g` - the graphics context
      `alloc` - the allocated region to paint into
      `index` - the child index, >= 0 && < getViewCount()

  - ### replace

    public void replace(int index, int length, View[] elems)
    Invalidates the layout and resizes the cache of requests/allocations. The child allocations can still be accessed for the old layout, but the new children will have an offset and span of 0.
    Overrides:
      `replace` in class `CompositeView`
    Parameters:
      `index` - the starting index into the child views to insert the new views; this should be a value >= 0 and <= getViewCount
      `length` - the number of existing child views to remove; This should be a value >= 0 and <= (getViewCount() - offset)
      `elems` - the child views to add; this value can be `null`to indicate no children are being added (useful to remove)

  - ### forwardUpdate

    protected void forwardUpdate(DocumentEvent.ElementChange ec, DocumentEvent e, Shape a, ViewFactory f)
    Forwards the given `DocumentEvent` to the child views that need to be notified of the change to the model. If a child changed its requirements and the allocation was valid prior to forwarding the portion of the box from the starting child to the end of the box will be repainted.
    Overrides:
      `forwardUpdate` in class `View`
    Parameters:
      `ec` - changes to the element this view is responsible for (may be `null` if there were no changes)
      `e` - the change information from the associated document
      `a` - the current allocation of the view
      `f` - the factory to use to rebuild if the view has children
    Since:
      1.3
    See Also:
      - `View.insertUpdate(DocumentEvent, Shape, ViewFactory)`
      - `View.removeUpdate(DocumentEvent, Shape, ViewFactory)`
      - `View.changedUpdate(DocumentEvent, Shape, ViewFactory)`

  - ### preferenceChanged

    public void preferenceChanged(View child, boolean width, boolean height)
    This is called by a child to indicate its preferred span has changed. This is implemented to throw away cached layout information so that new calculations will be done the next time the children need an allocation.
    Overrides:
      `preferenceChanged` in class `View`
    Parameters:
      `child` - the child view
      `width` - true if the width preference should change
      `height` - true if the height preference should change
    See Also:
      - `JComponent.revalidate()`

  - ### getResizeWeight

    public int getResizeWeight(int axis)
    Gets the resize weight. A value of 0 or less is not resizable.
    Overrides:
      `getResizeWeight` in class `View`
    Parameters:
      `axis` - may be either `View.X_AXIS` or `View.Y_AXIS`
    Returns:
      the weight
    Throws:
      `IllegalArgumentException` - for an invalid axis

  - ### setSize

    public void setSize(float width, float height)
    Sets the size of the view. This should cause layout of the view if the view caches any layout information. This is implemented to call the layout method with the sizes inside of the insets.
    Overrides:
      `setSize` in class `View`
    Parameters:
      `width` - the width >= 0
      `height` - the height >= 0

  - ### paint

    public void paint(Graphics g, Shape allocation)
    Renders the `BoxView` using the given rendering surface and area on that surface. Only the children that intersect the clip bounds of the given `Graphics` will be rendered.
    Specified by:
      `paint` in class `View`
    Parameters:
      `g` - the rendering surface to use
      `allocation` - the allocated region to render into
    See Also:
      - `View.paint(Graphics, Shape)`

  - ### getChildAllocation

    public Shape getChildAllocation(int index, Shape a)
    Fetches the allocation for the given child view. This enables finding out where various views are located. This is implemented to return `null` if the layout is invalid, otherwise the superclass behavior is executed.
    Overrides:
      `getChildAllocation` in class `CompositeView`
    Parameters:
      `index` - the index of the child, >= 0 && > getViewCount()
      `a` - the allocation to this view
    Returns:
      the allocation to the child; or `null` if `a` is `null`; or `null` if the layout is invalid

  - ### modelToView

    public Shape modelToView(int pos, Shape a, Position.Bias b) throws BadLocationException
    Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it. This makes sure the allocation is valid before calling the superclass.
    Overrides:
      `modelToView` in class `CompositeView`
    Parameters:
      `pos` - the position to convert >= 0
      `a` - the allocated region to render into
      `b` - a bias value of either `Position.Bias.Forward` or `Position.Bias.Backward`
    Returns:
      the bounding box of the given position
    Throws:
      `BadLocationException` - if the given position does not represent a valid location in the associated document
    See Also:
      - `View.modelToView(int, Shape, Position.Bias)`

  - ### viewToModel

    public int viewToModel(float x, float y, Shape a, Position.Bias[] bias)
    Provides a mapping from the view coordinate space to the logical coordinate space of the model.
    Overrides:
      `viewToModel` in class `CompositeView`
    Parameters:
      `x` - x coordinate of the view location to convert >= 0
      `y` - y coordinate of the view location to convert >= 0
      `a` - the allocated region to render into
      `bias` - either `Position.Bias.Forward` or `Position.Bias.Backward`
    Returns:
      the location within the model that best represents the given point in the view >= 0
    See Also:
      - `View.viewToModel(float, float, Shape, Position.Bias[])`

  - ### getAlignment

    public float getAlignment(int axis)
    Determines the desired alignment for this view along an axis. This is implemented to give the total alignment needed to position the children with the alignment points lined up along the axis orthogonal to the axis that is being tiled. The axis being tiled will request to be centered (i.e. 0.5f).
    Overrides:
      `getAlignment` in class `View`
    Parameters:
      `axis` - may be either `View.X_AXIS` or `View.Y_AXIS`
    Returns:
      the desired alignment >= 0.0f && <= 1.0f; this should be a value between 0.0 and 1.0 where 0 indicates alignment at the origin and 1.0 indicates alignment to the full span away from the origin; an alignment of 0.5 would be the center of the view
    Throws:
      `IllegalArgumentException` - for an invalid axis

  - ### getPreferredSpan

    public float getPreferredSpan(int axis)
    Determines the preferred span for this view along an axis.
    Specified by:
      `getPreferredSpan` in class `View`
    Parameters:
      `axis` - may be either `View.X_AXIS` or `View.Y_AXIS`
    Returns:
      the span the view would like to be rendered into >= 0; typically the view is told to render into the span that is returned, although there is no guarantee; the parent may choose to resize or break the view
    Throws:
      `IllegalArgumentException` - for an invalid axis type

  - ### getMinimumSpan

    public float getMinimumSpan(int axis)
    Determines the minimum span for this view along an axis.
    Overrides:
      `getMinimumSpan` in class `View`
    Parameters:
      `axis` - may be either `View.X_AXIS` or `View.Y_AXIS`
    Returns:
      the span the view would like to be rendered into >= 0; typically the view is told to render into the span that is returned, although there is no guarantee; the parent may choose to resize or break the view
    Throws:
      `IllegalArgumentException` - for an invalid axis type
    See Also:
      - `View.getPreferredSpan(int)`

  - ### getMaximumSpan

    public float getMaximumSpan(int axis)
    Determines the maximum span for this view along an axis.
    Overrides:
      `getMaximumSpan` in class `View`
    Parameters:
      `axis` - may be either `View.X_AXIS` or `View.Y_AXIS`
    Returns:
      the span the view would like to be rendered into >= 0; typically the view is told to render into the span that is returned, although there is no guarantee; the parent may choose to resize or break the view
    Throws:
      `IllegalArgumentException` - for an invalid axis type
    See Also:
      - `View.getPreferredSpan(int)`

  - ### isAllocationValid

    protected boolean isAllocationValid()
    Are the allocations for the children still valid?
    Returns:
      true if allocations still valid

  - ### isBefore

    protected boolean isBefore(int x, int y, Rectangle innerAlloc)
    Determines if a point falls before an allocated region.
    Specified by:
      `isBefore` in class `CompositeView`
    Parameters:
      `x` - the X coordinate >= 0
      `y` - the Y coordinate >= 0
      `innerAlloc` - the allocated region; this is the area inside of the insets
    Returns:
      true if the point lies before the region else false

  - ### isAfter

    protected boolean isAfter(int x, int y, Rectangle innerAlloc)
    Determines if a point falls after an allocated region.
    Specified by:
      `isAfter` in class `CompositeView`
    Parameters:
      `x` - the X coordinate >= 0
      `y` - the Y coordinate >= 0
      `innerAlloc` - the allocated region; this is the area inside of the insets
    Returns:
      true if the point lies after the region else false

  - ### getViewAtPoint

    protected View getViewAtPoint(int x, int y, Rectangle alloc)
    Fetches the child view at the given coordinates.
    Specified by:
      `getViewAtPoint` in class `CompositeView`
    Parameters:
      `x` - the X coordinate >= 0
      `y` - the Y coordinate >= 0
      `alloc` - the parents inner allocation on entry, which should be changed to the child's allocation on exit
    Returns:
      the view

  - ### childAllocation

    protected void childAllocation(int index, Rectangle alloc)
    Allocates a region for a child view.
    Specified by:
      `childAllocation` in class `CompositeView`
    Parameters:
      `index` - the index of the child view to allocate, >= 0 && < getViewCount()
      `alloc` - the allocated region

  - ### layout

    protected void layout(int width, int height)
    Perform layout on the box
    Parameters:
      `width` - the width (inside of the insets) >= 0
      `height` - the height (inside of the insets) >= 0

  - ### getWidth

    public int getWidth()
    Returns the current width of the box. This is the width that it was last allocated.
    Returns:
      the current width of the box

  - ### getHeight

    public int getHeight()
    Returns the current height of the box. This is the height that it was last allocated.
    Returns:
      the current height of the box

  - ### layoutMajorAxis

    protected void layoutMajorAxis(int targetSpan, int axis, int[] offsets, int[] spans)
    Performs layout for the major axis of the box (i.e. the axis that it represents). The results of the layout (the offset and span for each children) are placed in the given arrays which represent the allocations to the children along the major axis.
    Parameters:
      `targetSpan` - the total span given to the view, which would be used to layout the children
      `axis` - the axis being laid out
      `offsets` - the offsets from the origin of the view for each of the child views; this is a return value and is filled in by the implementation of this method
      `spans` - the span of each child view; this is a return value and is filled in by the implementation of this method

  - ### layoutMinorAxis

    protected void layoutMinorAxis(int targetSpan, int axis, int[] offsets, int[] spans)
    Performs layout for the minor axis of the box (i.e. the axis orthogonal to the axis that it represents). The results of the layout (the offset and span for each children) are placed in the given arrays which represent the allocations to the children along the minor axis.
    Parameters:
      `targetSpan` - the total span given to the view, which would be used to layout the children
      `axis` - the axis being laid out
      `offsets` - the offsets from the origin of the view for each of the child views; this is a return value and is filled in by the implementation of this method
      `spans` - the span of each child view; this is a return value and is filled in by the implementation of this method

  - ### calculateMajorAxisRequirements

    protected SizeRequirements calculateMajorAxisRequirements(int axis, SizeRequirements r)
    Calculates the size requirements for the major axis `axis`.
    Parameters:
      `axis` - the axis being studied
      `r` - the `SizeRequirements` object; if `null` one will be created
    Returns:
      the newly initialized `SizeRequirements` object
    See Also:
      - `SizeRequirements`

  - ### calculateMinorAxisRequirements

    protected SizeRequirements calculateMinorAxisRequirements(int axis, SizeRequirements r)
    Calculates the size requirements for the minor axis `axis`.
    Parameters:
      `axis` - the axis being studied
      `r` - the `SizeRequirements` object; if `null` one will be created
    Returns:
      the newly initialized `SizeRequirements` object
    See Also:
      - `SizeRequirements`

  - ### baselineLayout

    protected void baselineLayout(int targetSpan, int axis, int[] offsets, int[] spans)
    Computes the location and extent of each child view in this `BoxView` given the `targetSpan`, which is the width (or height) of the region we have to work with.
    Parameters:
      `targetSpan` - the total span given to the view, which would be used to layout the children
      `axis` - the axis being studied, either `View.X_AXIS` or `View.Y_AXIS`
      `offsets` - an empty array filled by this method with values specifying the location of each child view
      `spans` - an empty array filled by this method with values specifying the extent of each child view

  - ### baselineRequirements

    protected SizeRequirements baselineRequirements(int axis, SizeRequirements r)
    Calculates the size requirements for this `BoxView` by examining the size of each child view.
    Parameters:
      `axis` - the axis being studied
      `r` - the `SizeRequirements` object; if `null` one will be created
    Returns:
      the newly initialized `SizeRequirements` object

  - ### getOffset

    protected int getOffset(int axis, int childIndex)
    Fetches the offset of a particular child's current layout.
    Parameters:
      `axis` - the axis being studied
      `childIndex` - the index of the requested child
    Returns:
      the offset (location) for the specified child

  - ### getSpan

    protected int getSpan(int axis, int childIndex)
    Fetches the span of a particular child's current layout.
    Parameters:
      `axis` - the axis being studied
      `childIndex` - the index of the requested child
    Returns:
      the span (width or height) of the specified child

  - ### flipEastAndWestAtEnds

    protected boolean flipEastAndWestAtEnds(int position, Position.Bias bias)
    Determines in which direction the next view lays. Consider the View at index n. Typically the `View`s are laid out from left to right, so that the `View` to the EAST will be at index n + 1, and the `View` to the WEST will be at index n - 1. In certain situations, such as with bidirectional text, it is possible that the `View` to EAST is not at index n + 1, but rather at index n - 1, or that the `View` to the WEST is not at index n - 1, but index n + 1. In this case this method would return true, indicating the `View`s are laid out in descending order. Otherwise the method would return false indicating the `View`s are laid out in ascending order.

    If the receiver is laying its `View`s along the `Y_AXIS`, this will return the value from invoking the same method on the `View` responsible for rendering `position` and `bias`. Otherwise this will return false.

    Overrides:
      `flipEastAndWestAtEnds` in class `CompositeView`
    Parameters:
      `position` - position into the model
      `bias` - either `Position.Bias.Forward` or `Position.Bias.Backward`
    Returns:
      true if the `View`s surrounding the `View` responding for rendering `position` and `bias` are laid out in descending order; otherwise false